            LIST        P=PIC16F84A
            __CONFIG    H'3FF1'

W           EQU         H'0000'
F           EQU         H'0001'

PC          EQU         H'0002'
STATUS      EQU         H'0003'
PORTA       EQU         H'0005'
TRISA       EQU         H'0005'
PORTB       EQU         H'0006'
TRISB       EQU         H'0006'
INTCON      EQU         H'000B'

Reg_1       equ         H'000C'
Reg_2       equ         H'000D'
Reg_3       equ         H'000E'
Reg_4       equ         H'000F'
Reg_5       equ         H'0010'
Reg_6       equ         H'0011'
Reg_7       equ         H'0012'
Reg_8       equ         H'0013'


            org         0           ;               
;====================================
;  
Start       clrf        INTCON      ;   
            bsf         STATUS,5    ;    1 , .. TRISA TRISB   1
            movlw       b'00001000'
            movwf       TRISA
            clrf        TRISB
            bcf         STATUS,5    ;     0
            clrf        PORTA       ; ,      . 0
            clrf        PORTB
;====================================

;====================================
;   "" - " "
            clrw
            call        TABLE       ;    TABLE
            movwf       PORTB            
;   
KN_0        btfsc       PORTA,3     ;  .1 (  )
            goto        KN_0        ;    KN_0
            goto        KN_1        ;    KN_1
KN_1        btfss       PORTA,3     ;  .0 ( ),    
            goto        KN_1
;   (.1  RA0)
            movlw       b'00000001'
            movwf       PORTA
            call        Pause
            clrf        PORTA       ;  
;====================================            

;====================================
;       
M_1         movlw       .10
            movwf       Reg_5
M_3         decfsz      Reg_5, F
            goto        M_2
            goto        M_1           
M_2         movf        Reg_5,W
            call        TABLE       ;    TABLE

            movwf       PORTB
            call        Pause1
;        
            goto        M_3          ;   
;====================================

;====================================
;   
fiks        movf        Reg_5,W
            movwf       Reg_6

;   2 
            movlw       b'00000001'
            movwf       PORTA
            call        Pause
            clrf        PORTA       ;  
            call        Pause
            movlw       b'00000001'
            movwf       PORTA
            call        Pause
            clrf        PORTA       ;  
            call        Pause
;====================================

;====================================
;   
            movlw       .11          ;    ( 0  9  )
            movwf       Reg_5

;   
now         movlw       .255         ;  
            movwf       Reg_1        ;  
            movlw       .255         ;   
            movwf       Reg_2        ;  
            movlw       .1
            movwf       Reg_3

            movlw       b'00000001'
            movwf       PORTA
            call        Pause
            clrf        PORTA       ;  

            decfsz      Reg_5, F     ;  
            goto        M_4          ;  
            goto        M_5          ;               ;      
M_4         movf        Reg_5,W      ; 
            call        TABLE        ;  
            movwf       PORTB
;      
elektr      movlw       b'00000010'
            movwf       PORTA
            movf        Reg_6,W      
            movwf       Reg_7        
wr3         decfsz      Reg_7, F
            goto        wr3
            movlw       b'00000100'
            movwf       PORTA
            movf        Reg_6,W      
            movwf       Reg_7        
wr33        decfsz      Reg_7, F
            goto        wr33

            decfsz      Reg_1, F
            goto        elektr
            decfsz      Reg_2, F
            goto        elektr
;===========
;    
            btfss       PORTB,1
            goto        ON_dec
            goto        OF_dec
ON_dec      bsf         PORTB,1
            goto        dalee
OF_dec      bcf         PORTB,1
dalee
;===========
            decfsz      Reg_3, F
            goto        elektr

            goto        now
;====================================

M_5         movlw       b'00000001'
            movwf       PORTA
            call        Pause
            clrf        PORTA       ;  


            movlw       .6
            movwf       Reg_4
M_6         movlw       b'11110101'
            movwf       PORTB
            call        Pause
            clrf        PORTB
            call        Pause
            decfsz      Reg_4, F
            goto        M_6
            goto        M_5

;====================================
;  0,25 
; delay = 250'000 machine cycles
Pause       movlw       .169
            movwf       Reg_1
            movlw       .69
            movwf       Reg_2
            movlw       .2
            movwf       Reg_3
wr          decfsz      Reg_1, F
            goto        wr
            decfsz      Reg_2, F
            goto        wr
            decfsz      Reg_3, F
            goto        wr

            retlw       0
;====================================

;====================================
;  1  (  )
;delay = 1'000'000 machine cycles
Pause1      movlw       .173
            movwf       Reg_1
            movlw       .19
            movwf       Reg_2
            movlw       .6
            movwf       Reg_3
wr1         
            btfss       PORTA,3
            goto        fiks        
            decfsz      Reg_1, F
            goto        wr1
            decfsz      Reg_2, F
            goto        wr1
            decfsz      Reg_3, F
            goto        wr1

            retlw       0
;====================================

;====================================
;  5 
;delay = 5'000'000 machine cycles
Pause2      movlw       .110
            movwf       Reg_1
            movlw       .94
            movwf       Reg_2
            movlw       .26
            movwf       Reg_3
wr2         decfsz      Reg_1, F
            goto        wr2
            decfsz      Reg_2, F
            goto        wr2
            decfsz      Reg_3, F
            goto        wr2

            retlw       0
;====================================

;====================================
;   
TABLE       addwf      PC,F        ;    PC := PC + W
            retlw      b'00111101' ; 
            retlw      b'10111101' ; 9
            retlw      b'11111101' ; 8
            retlw      b'10000101' ; 7
            retlw      b'11111100' ; 6
            retlw      b'10111100' ; 5
            retlw      b'00110101' ; 4
            retlw      b'10101101' ; 3
            retlw      b'11101001' ; 2
            retlw      b'00000101' ; 1
            retlw      b'11011101' ; 0
;====================================


            end                     ;  
